<?php 
    // continue the session
    session_start();
    
    // init variables
    $updateLaborCategoryID=-1;
    $redirectPage=((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on'?"https" : "http") . "://" . $_SERVER['HTTP_HOST'] .  $_SERVER['REQUEST_URI']);
    
    // now determine if it was posted on the line
    if (isset($_GET['updateLaborCategoryID'])){
        // Default for the labor category ID is as a posted variable
        $updateLaborCategoryID=$_GET['updateLaborCategoryID'];
    }
    
    // Add includes to PHP files that I will need to access
    include 'php_only_scripts/database.php';
    include 'php_only_scripts/presentation.php';
    include 'php_only_scripts/user_presentation.php';

    // Init some variables
    $userRow=null;

    // Assume NOT gtg
    $gtg = false;

    // Create and Setup the database
    $db = new Database();
    $db->setupTmsDB();

    // Attempt to log in with this user
    $currentUser = $db->getLoggedInSessionUser(session_id());
    
    // If there is only one result for a username/password combo, then they are good to go.
    if ($currentUser == null){
        exit;
    }
    elseif (mysqli_num_rows($currentUser)==1){
        // Attempt to get the user row
        $userRow = $currentUser->fetch_assoc();
        
        // Determine if this user has access to this page
        if ($userRow["UserLevel"]=='TIMECARD ONLY' ||
            $userRow["SUEmployee"]!=1 ||
            $updateLaborCategoryID == -1 ||
            $userRow["AccountStatus"]!='ACTIVE'){
            // redirect to the invalid access page
            echo ('<script>window.location = "invalid_access.php";</script>');

            exit;
        }
        
        // Set the good to go until they log out
        $gtg = true;

        // Determine if BOTH the user name AND password has been set
        if (isset($_POST['formSubmitted']) && 
            htmlspecialchars($_POST['formSubmitted'])=='TRUE'){
            // Determine if this user can even modify
            if (!$userRow["CanModify"]){
                // redirect to the labor categories page
                echo ('<script>window.location = "laborcategories.php";</script>');
            }
            else {
                // Change the form back to NOT being submitted
                $_SESSION['formSubmitted']='FALSE';

                // Set the local variables from what was posted
                $name=htmlspecialchars($_POST['name'], ENT_QUOTES, 'UTF-8');
                $description = htmlspecialchars($_POST['description'], ENT_QUOTES, 'UTF-8');
                $rowColor=htmlspecialchars($_POST['rowColor'], ENT_QUOTES, 'UTF-8');
                $isOnTheClock=htmlspecialchars(isset($_POST['isOnTheClock'])?1:0);
                $isDailyReset=htmlspecialchars(isset($_POST['isDailyReset'])?1:0);
                
                // Let's create the update query off of what we have
                $sql='UPDATE laborcategories SET IsOnTheClock=' . $isOnTheClock;
                $sql=$sql . ', IsDailyReset=' . $isDailyReset;
                if ($name!=null) {$sql = $sql . ', Name=\'' . $name . '\'';}
                if ($description!=null) {$sql = $sql . ', Description=\'' . $description . '\'';} 
                if ($rowColor!=null) {$sql = $sql . ', RowColor=\'' . $rowColor . '\'';}
                $sql=$sql .' WHERE LaborCategoryID=' . $updateLaborCategoryID . ';';

                // Attempt to run the query and evaluate the response
                if ($db->queryDB($sql, $userRow, "updateLaborCategory Form occurance 1")){
                    // redirect to the labor categories page
                    echo ('<script>window.location = "laborCategories.php";</script>');
                }
                else{
                    echo '<script>alert("Labor Category was NOT updated in the database. Please check the data and try again.");</script>';
                    // TODO: How do I want to display a failure to the user?
                }
            }
        }
        else {
            // Set the form submitted session variable to FALSE
            $_POST['formSubmitted']='FALSE';
        }
    }
?>
        
﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

    <title>Task Management System - Update Labor Category</title>

    <meta name="keywords" content="GIS,data,testing,IT" />
    <meta name="description" content="EES Divisions." />

    <script src="./SpryAssets/SpryMenuBar.js" type="text/javascript"></script>
    <script src="./javascript/addresses.js" type="text/javascript"></script>
    <script src="scripts/jpicker-1.1.6/jquery-1.4.4.min.js" type="text/javascript"></script>
    <script src="scripts/jpicker-1.1.6/jpicker-1.1.6.min.js" type="text/javascript"></script>
    <script language="JavaScript" src="scripts/gen_validatorv4.js" type="text/javascript"></script>
    
    <link rel="icon" href="images/ees_ico.ico"/> 
    
    <link href="scripts/jpicker-1.1.6/css/jPicker-1.1.6.css" rel="stylesheet" type="text/css"/>
    <link href="./SpryAssets/SpryMenuBarHorizontal.css" rel="stylesheet" type="text/css" />
    <link href="./SpryAssets/SpryMenuBarVertical.css" rel="stylesheet" type="text/css" />
    <link rel = "stylesheet" type="text/css" href="./css/contentpage.css" >
</head>

<script type="text/javascript">
  $(function()
    {
      $.fn.jPicker.defaults.images.clientPath='scripts/jpicker-1.1.6/images/';
    });
</script>

<body class="thrColElsHdr">

<div id="container">
  
<!-- start of banner wrap --->

<div id="topContent">
  
<div>
   <div class="MenuBarHorizontal" id="navBar">  <ul id="TopNav" class="MenuBarHorizontal">

    <script type="text/javascript">
    <!--
    var MenuBar2 = new Spry.Widget.MenuBar("TopNav", {imgDown:"./SpryAssets/SpryMenuBarDownHover.gif", imgRight:"./SpryAssets/SpryMenuBarRightHover.gif"});
    //-->
    </script>

    </div>
  </div>
</div>
<!-- end of banner wrap --->

  <!-- end #header -->
  <br class="clearfloat" />
  <div id="sidebar1">
      <?php 
        // Determine if we are GTG
        if ($gtg){
          // Render the appropriate presentation for the tasks sidebar
          getSidebar($userRow, 'timecard');
        }
      ?>       
      <br class="clearfloat" />
  <!-- end #sidebar1 -->
  </div>
  
  <!-- start #mainContent -->
  <div id="mainContent">
    <div class="maintitle">Task Management System - Update Labor Category</div>
    <div class="breadcrumb"> <a href="../index.html"> Home </a> > <a href="laborCategories.php"> Labor Categories </a> > <a href=
          "<?php echo ($redirectPage); ?>"> Update Labor Categories </a></div>

    <br>
    <?php
        // Determine if they are GTG
        if ($gtg){
            echo getLaborCategory($db, $userRow, $updateLaborCategoryID);
        }
        else {
            // Set the login failed to true
            $_SESSION['failedLogin']='TRUE';

            // Add a session variable that is this page URL
            $_SESSION['pageToGoTo']=$redirectPage;

            // redirect to the login page
            echo ('<script>window.location = ".";</script>');
        }
    ?>       
    
  <!-- end #mainContent -->
  
  <!-- This clearing element should immediately follow the #mainContent div in order to force the #container div to contain all child floats -->
  <br class="clearfloat" />
  
  <!-- start #footer --></div>
   <div id="footer">
    <p>© 2018 Evolve Engineering and Software. EES, Evolve Engineering and Software, EES Logo are registered marks of Evolve Engineering and Software.</p>
  <!-- end #footer -->
   </div>
<!-- end #container -->
</div>

</body>

</html>